﻿package {

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.net.*;
	import flash.utils.*;
	import flash.text.*;
	
	public class LoaderToStage extends MovieClip {
				
		private var Progress:MovieClip = new MovieClip();
		private var Percentage:TextField = new TextField();
		private var ResizeTimer:Timer = new Timer(20);
		
		public function LoaderToStage(stage, Link) {
			
			var NewMovieClip:MovieClip = new MovieClip();
			stage.addChild(NewMovieClip);
			var myUILoader:Loader = new Loader();
			var request:URLRequest = new URLRequest(Link);
            configureListeners(myUILoader.contentLoaderInfo);
			myUILoader.load(request);
            NewMovieClip.addChild(myUILoader);
			NewMovieClip.addChild(Percentage);
			NewMovieClip.addChild(Progress);
			function configureListeners(dispatcher:IEventDispatcher):void {
            	dispatcher.addEventListener(Event.OPEN, openHandler);
            	dispatcher.addEventListener(ProgressEvent.PROGRESS, progressHandler);
            	dispatcher.addEventListener(Event.INIT, initHandler);
            	dispatcher.addEventListener(HTTPStatusEvent.HTTP_STATUS, httpStatusHandler);
            	dispatcher.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
            	dispatcher.addEventListener(Event.UNLOAD, unLoadHandler);
        		dispatcher.addEventListener(Event.COMPLETE, completeHandler);
            }	
			function httpStatusHandler(event:HTTPStatusEvent):void {
				//trace("httpStatusHandler: " + event);
			}
			function initHandler(event:Event):void {
				//trace("initHandler: " + event);
			}
			function ioErrorHandler(event:IOErrorEvent):void {
				//trace("ioErrorHandler: " + event);
			}
			function openHandler(event:Event):void {
				Progress.graphics.beginFill(0x123456, 0.5);
				Progress.graphics.drawRect(stage.stageWidth * 0.4, stage.stageHeight * 0.4, stage.stageWidth * 0.2, stage.stageHeight * 0.01);
				Progress.graphics.endFill();
				Percentage.x = stage.stageWidth * 0.42;
				Percentage.y = stage.stageHeight * 0.48;
				Percentage.width = stage.stageWidth * 0.3;
				//trace("openHandler: " + event);
			}
			function unLoadHandler(event:Event):void {
				//trace("unLoadHandler: " + event);
			}
			function progressHandler(event:ProgressEvent):void {
				//trace("progressHandler: bytesLoaded=" + event.bytesLoaded + " bytesTotal=" + event.bytesTotal);
				var kbLoaded:String = Number(event.bytesLoaded / 1024).toFixed(1);
				var kbTotal:String = Number(event.bytesTotal / 1024).toFixed(1);
				Percentage.text = kbLoaded + "KB of " + kbTotal + "KB" + " (" + Math.floor(100 * event.bytesLoaded / event.bytesTotal) + "%)";
				Progress.graphics.beginFill(0xeeeeee, 0.5);
				Progress.graphics.drawRect(stage.stageWidth * 0.4, stage.stageHeight * 0.39, stage.stageWidth * 0.2 * event.bytesLoaded / event.bytesTotal, stage.stageHeight * 0.03);
				Progress.graphics.endFill();
			}			
			function completeHandler(event:Event):void {
				//trace("completeHandler: " + event+ "\n\n");
            	myUILoader.contentLoaderInfo.removeEventListener(HTTPStatusEvent.HTTP_STATUS, httpStatusHandler);
            	myUILoader.contentLoaderInfo.removeEventListener(Event.INIT, initHandler);
            	myUILoader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
            	myUILoader.contentLoaderInfo.removeEventListener(Event.OPEN, openHandler);
            	myUILoader.contentLoaderInfo.removeEventListener(Event.UNLOAD, unLoadHandler);
				myUILoader.contentLoaderInfo.removeEventListener(ProgressEvent.PROGRESS, progressHandler);
				myUILoader.contentLoaderInfo.removeEventListener(Event.COMPLETE, completeHandler);
				NewMovieClip.removeChild(Percentage);
				NewMovieClip.removeChild(Progress);
				NewMovieClip.width = 0;
				NewMovieClip.height = 0;
				var Scale:Number = 0.02;
				var AddTime:Timer = new Timer(20);
				AddTime.addEventListener(TimerEvent.TIMER, AddPicture);
				AddTime.start();
				function AddPicture(event:TimerEvent):void {
					NewMovieClip.alpha = Scale;
					NewMovieClip.width = Scale * stage.stageWidth;
					NewMovieClip.height = Scale * stage.stageHeight;
					Scale += 0.02;
					if(Scale > 1) {
						AddTime.removeEventListener(TimerEvent.TIMER, AddPicture);
						ResizeTimer.addEventListener(TimerEvent.TIMER, ResizePicture);
						ResizeTimer.start();
					}
				}
				function ResizePicture(event:TimerEvent):void {
					NewMovieClip.width = stage.stageWidth;
					NewMovieClip.height = stage.stageHeight;
				}
				NewMovieClip.buttonMode = enabled;
				NewMovieClip.addEventListener(MouseEvent.MOUSE_DOWN, RemoveFromStage);
				function RemoveFromStage(event:MouseEvent):void {
					NewMovieClip.removeEventListener(MouseEvent.MOUSE_DOWN, RemoveFromStage);
					ResizeTimer.removeEventListener(TimerEvent.TIMER, ResizePicture);
					var NrTime:Number = 1;
					var OffTime:Timer = new Timer(50);
					OffTime.addEventListener(TimerEvent.TIMER, OffPicture);
					OffTime.start();
					function OffPicture(event:TimerEvent):void {
						NrTime -= 0.05;
						NewMovieClip.alpha = NrTime;
						NewMovieClip.rotation -= 10;
						NewMovieClip.scaleX *= 0.8;
						NewMovieClip.scaleY *= 0.8;
						if(NrTime < 0.15) {
							OffTime.removeEventListener(TimerEvent.TIMER, OffPicture);
							NewMovieClip.removeChild(myUILoader);
							stage.removeChild(NewMovieClip);
						}
					}
				}
			}
		}
	}
}
